
/*  A Bison parser, made from ebnf.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define YYLSP_NEEDED

#define	INCLUDE	257
#define	SIMPLE	258
#define	CHANNEL	259
#define	DELAY	260
#define	ERROR	261
#define	DATARATE	262
#define	MODULE	263
#define	PARAMETERS	264
#define	GATES	265
#define	GATESIZES	266
#define	SUBMODULES	267
#define	CONNECTIONS	268
#define	DISPLAY	269
#define	IN	270
#define	OUT	271
#define	NOCHECK	272
#define	LEFT_ARROW	273
#define	RIGHT_ARROW	274
#define	FOR	275
#define	TO	276
#define	DO	277
#define	IF	278
#define	LIKE	279
#define	NETWORK	280
#define	ENDSIMPLE	281
#define	ENDMODULE	282
#define	ENDCHANNEL	283
#define	ENDNETWORK	284
#define	ENDFOR	285
#define	MACHINES	286
#define	ON	287
#define	IO_INTERFACES	288
#define	IFPAIR	289
#define	INTCONSTANT	290
#define	REALCONSTANT	291
#define	NAME	292
#define	STRING	293
#define	_TRUE	294
#define	_FALSE	295
#define	INPUT	296
#define	REF	297
#define	ANCESTOR	298
#define	NED_CONST	299
#define	NUMERICTYPE	300
#define	STRINGTYPE	301
#define	BOOLTYPE	302
#define	ANYTYPE	303
#define	PLUS	304
#define	MIN	305
#define	MUL	306
#define	DIV	307
#define	MOD	308
#define	EXP	309
#define	SIZEOF	310
#define	SUBMODINDEX	311
#define	EQ	312
#define	NE	313
#define	GT	314
#define	GE	315
#define	LS	316
#define	LE	317
#define	AND	318
#define	OR	319
#define	XOR	320
#define	NOT	321
#define	BIN_AND	322
#define	BIN_OR	323
#define	BIN_XOR	324
#define	BIN_COMPL	325
#define	SHIFT_LEFT	326
#define	SHIFT_RIGHT	327
#define	INVALID_CHAR	328
#define	UMIN	329

#line 77 "ebnf.y"


/*
 * Note:
 * This file (ebnf.y) and ebnf.lex are shared between NEDC and GNED.
 * (Exactly the same files are present in both packages;
 * this is to eliminate the burden of keeping 2 sets of files in sync.)
 *
 * Naturally, NEDC and GNED want to do different things while parsing.
 * Both code is present in this file, using the GNED(), NEC(), DOING_GNED,
 * DOING_NEDC macros. These macros come from ebnfcfg.h which is different
 * in gned and nedc.
 *
 * IMPORTANT:
 * If a grammar rule contains code for both nedc and gned, DO _NOT_ PUT THE
 * NEDC() AND GNED() MACROS IN SEPARATE BRACE PAIRS!
 * So this is WRONG:
 *               {NEDC(...)}
 *               {GNED(...)}
 * This is right:
 *               {NEDC(...)
 *                GNED(...)}
 * The reason is that Bison doesn't handle multiple subsequent actions
 * very well; what's worse, it doesn't even warn about them.
 */


/*
 * Note 2:
 * This file contains 2 shift-reduce conflicts around 'timeconstant'.
 * 4 more at opt_semicolon's after module/submodule types.
 * Plus 3 more to track down.
 *
 * bison's "%expect nn" option cannot be used to suppress the
 * warning message because %expect is not recognized by yacc
 */


#include <stdio.h>
#include <malloc.h>         /* for alloca() */
#include "ebnf.h"           /* selects between NEDC and GNED */
#include "ebnfcfg.h"        /* selects between NEDC and GNED */

#define YYDEBUG 1           /* allow debugging */
#define YYDEBUGGING_ON 0    /* turn on/off debugging */

#if YYDEBUG != 0
#define YYERROR_VERBOSE     /* more detailed error messages */
#include <string.h>         /* YYVERBOSE needs it */
#endif


int yylex (void);
void yyrestart(FILE *);
void yyerror (char *s);


//
// stuff needed by NEDC
//
#ifdef DOING_NEDC
#include "jar_func.h"
#include "jar_lib.h"
#endif


//
// stuff needed by GNED
//
#ifdef DOING_GNED

#include "parsened.h"
#include "nedfile.h"
#include "disp.h"

static YYLTYPE NULLPOS={0,0,0,0,0,0};
static int in_loop;
static int in_network;

NEDParser *np;

#define NEDFILE_KEY       np->nedfile_key
#define IMPORTS_KEY       np->imports_key
#define IMPORT_KEY        np->import_key
#define CHANNEL_KEY       np->channel_key
#define CHANATTR_KEY      np->chanattr_key
#define NETWORK_KEY       np->network_key
#define MODULE_KEY        np->module_key  // also plays the role of SIMPLE_KEY
#define PARAMS_KEY        np->params_key
#define PARAM_KEY         np->param_key
#define GATES_KEY         np->gates_key
#define GATE_KEY          np->gate_key
#define MACHINES_KEY      np->machines_key
#define MACHINE_KEY       np->machine_key
#define SUBMODS_KEY       np->submods_key
#define SUBMOD_KEY        np->submod_key
#define SUBSTPARAMS_KEY   np->substparams_key
#define SUBSTPARAM_KEY    np->substparam_key
#define GATESIZES_KEY     np->gatesizes_key
#define GATESIZE_KEY      np->gatesize_key
#define SUBSTMACHINES_KEY np->substmachines_key
#define SUBSTMACHINE_KEY  np->substmachine_key
#define CONNS_KEY         np->conns_key
#define CONN_KEY          np->conn_key
#define CONNATTR_KEY      np->connattr_key
#define FORLOOP_KEY       np->forloop_key
#define LOOPVAR_KEY       np->loopvar_key

void setFileComment(int key);
void setBannerComment(int key, YYLTYPE tokenpos);
void setRightComment(int key, YYLTYPE tokenpos);
void setTrailingComment(int key, YYLTYPE tokenpos);
void setComments(int key, YYLTYPE pos);
void setComments(int key, YYLTYPE firstpos, YYLTYPE lastpos);
int addChanAttr(int channel_key, char *attrname, YYLTYPE valuepos);
int addParameter(int params_key, YYLTYPE namepos, int type);
int addGate(int gates_key, YYLTYPE namepos, int is_in, int is_vector );
int addSubmodule(int submods_key, YYLTYPE namepos, YYLTYPE vectorpos,
                                   YYLTYPE typepos,YYLTYPE likepos);
int addGateSize(int gatesizes_key, YYLTYPE namepos, YYLTYPE vectorpos);
int addSubstparam(int substparams_key, YYLTYPE namepos, YYLTYPE valuepos);
int addSubstmachine(int substmachines_key, YYLTYPE namepos);
int addConnAttr(int conn_key, char *attrname, YYLTYPE valuepos);
int addLoopVar(int forloop_key, YYLTYPE varnamepos, YYLTYPE frompos, YYLTYPE topos);
int addNetwork(int nedfile_key, YYLTYPE namepos, YYLTYPE typepos, YYLTYPE likepos);
int findSubmoduleKey(YYLTYPE modulenamepos);
YYLTYPE trimBrackets(YYLTYPE vectorpos);
YYLTYPE trimQuotes(YYLTYPE vectorpos);
void swapConnection(int conn_key);
void setDisplayString(int key, YYLTYPE dispstrpos);
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		499
#define	YYFLAG		-32768
#define	YYNTBASE	86

#define YYTRANSLATE(x) ((unsigned)(x) <= 329 ? yytranslate[x] : 222)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    84,
    85,     2,     2,    78,     2,    83,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    76,    79,     2,
    82,     2,    75,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    80,     2,    81,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    77
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,    10,    12,    14,    16,    18,
    19,    23,    27,    30,    32,    35,    39,    43,    47,    52,
    57,    62,    67,    72,    77,    83,    89,    95,   101,   107,
   113,   116,   117,   122,   123,   127,   131,   135,   139,   145,
   149,   153,   156,   165,   169,   173,   176,   178,   179,   181,
   182,   184,   185,   187,   188,   190,   191,   193,   194,   195,
   200,   202,   203,   207,   210,   212,   217,   218,   223,   225,
   226,   227,   232,   235,   237,   241,   244,   248,   253,   258,
   262,   266,   270,   271,   276,   278,   279,   283,   286,   290,
   293,   297,   300,   304,   306,   310,   313,   317,   319,   320,
   325,   327,   328,   331,   333,   334,   335,   344,   345,   346,
   356,   357,   358,   369,   370,   371,   383,   384,   389,   391,
   392,   395,   397,   398,   403,   404,   411,   413,   414,   418,
   421,   423,   425,   426,   429,   431,   432,   437,   438,   445,
   447,   448,   452,   455,   459,   462,   463,   464,   469,   470,
   477,   479,   480,   484,   487,   490,   492,   497,   498,   499,
   505,   506,   511,   513,   514,   518,   521,   523,   525,   526,
   533,   537,   539,   545,   548,   549,   552,   553,   557,   560,
   566,   574,   580,   588,   592,   594,   597,   599,   602,   604,
   607,   609,   613,   615,   618,   620,   623,   625,   628,   630,
   631,   633,   635,   637,   639,   642,   645,   648,   651,   654,
   657,   661,   665,   669,   673,   677,   681,   683,   686,   689,
   692,   693,   694,   695,   707,   708,   709,   710,   724,   727,
   731,   733,   735,   742,   747,   751,   753,   755,   757,   761,
   765,   769,   773,   777,   781,   785,   788,   792,   796,   800,
   804,   808,   812,   816,   820,   824,   827,   831,   835,   839,
   842,   846,   850,   856,   860,   865,   872,   881,   883,   885,
   887,   889,   891,   893,   896,   899,   903,   907,   911,   916,
   921,   927,   929,   931,   933,   935,   937,   942,   944,   946,
   948,   952,   956,   959,   962,   964,   965,   967,   969
};

static const short yyrhs[] = {    87,
     0,     0,    88,    87,     0,    88,     0,    89,     0,    93,
     0,   101,     0,   104,     0,   199,     0,     0,     3,    90,
    91,     0,    92,    78,    91,     0,    92,    79,     0,    39,
     0,    94,    95,     0,    94,    99,    95,     0,    94,    98,
    95,     0,    94,   100,    95,     0,    94,    99,    98,    95,
     0,    94,    99,   100,    95,     0,    94,    98,   100,    95,
     0,    94,    98,    99,    95,     0,    94,   100,    99,    95,
     0,    94,   100,    98,    95,     0,    94,    99,    98,   100,
    95,     0,    94,    99,   100,    98,    95,     0,    94,    98,
    99,   100,    95,     0,    94,    98,   100,    99,    95,     0,
    94,   100,    99,    98,    95,     0,    94,   100,    98,    99,
    95,     0,     5,    38,     0,     0,    29,    38,   220,    96,
     0,     0,    29,   220,    97,     0,     7,   210,   220,     0,
     6,   210,   220,     0,     8,   210,   220,     0,   102,   107,
   109,   110,   103,     0,     4,    38,   220,     0,    27,    38,
   220,     0,    27,   220,     0,   105,   107,   109,   110,   111,
   112,   108,   106,     0,     9,    38,   220,     0,    28,    38,
   220,     0,    28,   220,     0,   113,     0,     0,   118,     0,
     0,   119,     0,     0,   125,     0,     0,   133,     0,     0,
   172,     0,     0,     0,    32,    76,   114,   115,     0,   116,
     0,     0,   117,    78,   116,     0,   117,    79,     0,    38,
     0,    15,    76,    39,    79,     0,     0,    10,    76,   120,
   121,     0,   122,     0,     0,     0,   124,    78,   123,   122,
     0,   124,    79,     0,    38,     0,    38,    76,    46,     0,
    45,    38,     0,    38,    76,    45,     0,    38,    76,    45,
    46,     0,    38,    76,    46,    45,     0,    38,    76,    47,
     0,    38,    76,    48,     0,    38,    76,    49,     0,     0,
    11,    76,   126,   127,     0,   128,     0,     0,    16,   129,
   128,     0,    16,   129,     0,    17,   131,   128,     0,    17,
   131,     0,   130,    78,   129,     0,   130,    79,     0,    38,
    80,    81,     0,    38,     0,   132,    78,   131,     0,   132,
    79,     0,    38,    80,    81,     0,    38,     0,     0,    13,
    76,   134,   135,     0,   136,     0,     0,   137,   136,     0,
   137,     0,     0,     0,    38,    76,    38,   220,   138,   148,
   139,   146,     0,     0,     0,    38,    76,    38,   207,   220,
   140,   148,   141,   146,     0,     0,     0,    38,    76,    38,
    25,    38,   220,   142,   148,   143,   146,     0,     0,     0,
    38,    76,    38,   207,    25,    38,   220,   144,   148,   145,
   146,     0,     0,   156,   147,   164,   171,     0,   149,     0,
     0,   150,   149,     0,   150,     0,     0,    33,    76,   151,
   153,     0,     0,    33,    24,   210,    76,   152,   153,     0,
   154,     0,     0,   155,    78,   154,     0,   155,    79,     0,
    38,     0,   157,     0,     0,   158,   157,     0,   158,     0,
     0,    10,    76,   159,   161,     0,     0,    10,    24,   210,
    76,   160,   161,     0,   162,     0,     0,   163,    78,   162,
     0,   163,    79,     0,    38,    82,   208,     0,   165,   164,
     0,     0,     0,    12,    76,   166,   168,     0,     0,    12,
    24,   210,    76,   167,   168,     0,   169,     0,     0,   170,
    78,   169,     0,   170,    79,     0,    38,   207,     0,    38,
     0,    15,    76,    39,    79,     0,     0,     0,    14,    18,
    76,   173,   175,     0,     0,    14,    76,   174,   175,     0,
   176,     0,     0,   177,   221,   176,     0,   177,    79,     0,
   178,     0,   185,     0,     0,    21,   179,   180,    23,   184,
    31,     0,   181,    78,   180,     0,   181,     0,    38,    82,
   210,    22,   210,     0,    24,   210,     0,     0,    15,    39,
     0,     0,   185,   221,   184,     0,   185,    79,     0,   186,
    20,   190,   182,   183,     0,   186,    20,   194,    20,   190,
   182,   183,     0,   186,    19,   190,   182,   183,     0,   186,
    19,   194,    19,   190,   182,   183,     0,   187,    83,   188,
     0,   189,     0,    38,   207,     0,    38,     0,    38,   207,
     0,    38,     0,    38,   207,     0,    38,     0,   191,    83,
   192,     0,   193,     0,    38,   207,     0,    38,     0,    38,
   207,     0,    38,     0,    38,   207,     0,    38,     0,     0,
   195,     0,   196,     0,   197,     0,   198,     0,   196,   197,
     0,   196,   198,     0,   197,   198,     0,   197,   196,     0,
   198,   196,     0,   198,   197,     0,   196,   197,   198,     0,
   196,   198,   197,     0,   197,   196,   198,     0,   197,   198,
   196,     0,   198,   196,   197,     0,   198,   197,   196,     0,
    38,     0,     6,   210,     0,     7,   210,     0,     8,   210,
     0,     0,     0,     0,    26,    38,    76,    38,   220,   200,
   148,   201,   156,   202,   206,     0,     0,     0,     0,    26,
    38,    76,    38,    25,    38,   220,   203,   148,   204,   156,
   205,   206,     0,    30,   220,     0,    80,   210,    81,     0,
   209,     0,   210,     0,    42,    84,   210,    78,   210,    85,
     0,    42,    84,   210,    85,     0,    42,    84,    85,     0,
    42,     0,   211,     0,   212,     0,    84,   211,    85,     0,
   211,    50,   211,     0,   211,    51,   211,     0,   211,    52,
   211,     0,   211,    53,   211,     0,   211,    54,   211,     0,
   211,    55,   211,     0,    51,   211,     0,   211,    58,   211,
     0,   211,    59,   211,     0,   211,    60,   211,     0,   211,
    61,   211,     0,   211,    62,   211,     0,   211,    63,   211,
     0,   211,    64,   211,     0,   211,    65,   211,     0,   211,
    66,   211,     0,    67,   211,     0,   211,    68,   211,     0,
   211,    69,   211,     0,   211,    70,   211,     0,    71,   211,
     0,   211,    72,   211,     0,   211,    73,   211,     0,   211,
    75,   211,    76,   211,     0,    38,    84,    85,     0,    38,
    84,   211,    85,     0,    38,    84,   211,    78,   211,    85,
     0,    38,    84,   211,    78,   211,    78,   211,    85,     0,
   213,     0,   214,     0,   215,     0,   216,     0,   217,     0,
    38,     0,    43,    38,     0,    44,    38,     0,    43,    44,
    38,     0,    44,    43,    38,     0,    38,    83,    38,     0,
    43,    38,    83,    38,     0,    38,   207,    83,    38,     0,
    43,    38,   207,    83,    38,     0,    39,     0,    40,     0,
    41,     0,   218,     0,    57,     0,    56,    84,    38,    85,
     0,    36,     0,    37,     0,   219,     0,    36,    38,   219,
     0,    37,    38,   219,     0,    36,    38,     0,    37,    38,
     0,    79,     0,     0,    78,     0,    79,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   214,   215,   219,   220,   224,   225,   226,   227,   228,   232,
   236,   241,   242,   246,   255,   258,   260,   262,   265,   267,
   269,   271,   273,   275,   278,   280,   282,   284,   286,   288,
   293,   302,   304,   305,   307,   312,   319,   326,   333,   341,
   350,   353,   359,   370,   378,   381,   387,   388,   391,   391,
   392,   392,   393,   393,   394,   394,   395,   395,   398,   402,
   405,   406,   410,   411,   414,   422,   428,   433,   436,   437,
   441,   444,   444,   449,   452,   455,   458,   461,   464,   467,
   470,   473,   479,   484,   487,   488,   492,   493,   494,   495,
   499,   500,   504,   508,   515,   516,   520,   524,   531,   536,
   539,   540,   544,   545,   549,   554,   556,   556,   561,   563,
   563,   568,   570,   570,   575,   577,   580,   583,   588,   589,
   594,   595,   599,   604,   604,   610,   614,   615,   620,   621,
   625,   632,   633,   637,   638,   642,   647,   647,   653,   656,
   657,   661,   662,   666,   673,   674,   678,   683,   683,   689,
   692,   693,   697,   698,   702,   706,   713,   716,   720,   726,
   726,   732,   735,   736,   740,   741,   745,   746,   750,   754,
   760,   761,   765,   772,   775,   780,   783,   788,   789,   793,
   796,   799,   803,   810,   811,   815,   820,   827,   831,   837,
   843,   851,   852,   856,   860,   866,   870,   876,   881,   889,
   891,   893,   895,   897,   900,   902,   904,   906,   908,   910,
   913,   915,   917,   919,   921,   923,   928,   934,   940,   946,
   952,   957,   959,   961,   962,   965,   969,   971,   975,   980,
   985,   986,   990,   992,   994,   996,  1001,  1007,  1009,  1012,
  1014,  1016,  1018,  1020,  1022,  1025,  1029,  1031,  1033,  1035,
  1037,  1039,  1042,  1044,  1046,  1048,  1052,  1054,  1056,  1058,
  1061,  1063,  1065,  1067,  1069,  1071,  1073,  1078,  1079,  1080,
  1081,  1082,  1086,  1088,  1090,  1092,  1094,  1097,  1099,  1102,
  1104,  1109,  1114,  1116,  1121,  1126,  1128,  1133,  1134,  1135,
  1139,  1141,  1143,  1145,  1150,  1150,  1151,  1151,  1151
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INCLUDE",
"SIMPLE","CHANNEL","DELAY","ERROR","DATARATE","MODULE","PARAMETERS","GATES",
"GATESIZES","SUBMODULES","CONNECTIONS","DISPLAY","IN","OUT","NOCHECK","LEFT_ARROW",
"RIGHT_ARROW","FOR","TO","DO","IF","LIKE","NETWORK","ENDSIMPLE","ENDMODULE",
"ENDCHANNEL","ENDNETWORK","ENDFOR","MACHINES","ON","IO_INTERFACES","IFPAIR",
"INTCONSTANT","REALCONSTANT","NAME","STRING","_TRUE","_FALSE","INPUT","REF",
"ANCESTOR","NED_CONST","NUMERICTYPE","STRINGTYPE","BOOLTYPE","ANYTYPE","PLUS",
"MIN","MUL","DIV","MOD","EXP","SIZEOF","SUBMODINDEX","EQ","NE","GT","GE","LS",
"LE","AND","OR","XOR","NOT","BIN_AND","BIN_OR","BIN_XOR","BIN_COMPL","SHIFT_LEFT",
"SHIFT_RIGHT","INVALID_CHAR","'?'","':'","UMIN","','","';'","'['","']'","'='",
"'.'","'('","')'","networkdescription","somedefinitions","definition","import",
"@1","filenames","filename","channeldefinition","channelheader","endchannel",
"@2","@3","cherror","chdelay","chdatarate","simpledefinition","simpleheader",
"endsimple","moduledefinition","moduleheader","endmodule","opt_machineblock",
"opt_displayblock","opt_paramblock","opt_gateblock","opt_submodblock","opt_connblock",
"machineblock","@4","opt_machinelist","machinelist","machine","displayblock",
"paramblock","@5","opt_parameters","parameters","@6","parameter","gateblock",
"@7","opt_gates","gates","gatesI","gateI","gatesO","gateO","submodblock","@8",
"opt_submodules","submodules","submodule","@9","@10","@11","@12","@13","@14",
"@15","@16","submodule_body","@17","opt_on_blocks","on_blocks","on_block","@18",
"@19","opt_on_list","on_list","on_mach","opt_substparamblocks","substparamblocks",
"substparamblock","@20","@21","opt_substparameters","substparameters","substparameter",
"opt_gatesizeblocks","gatesizeblock","@22","@23","opt_gatesizes","gatesizes",
"gatesize","opt_submod_displayblock","connblock","@24","@25","opt_connections",
"connections","connection","loopconnection","@26","loopvarlist","loopvar","opt_conn_condition",
"opt_conn_displaystr","notloopconnections","notloopconnection","gate_spec_L",
"mod_L","gate_L","parentgate_L","gate_spec_R","mod_R","gate_R","parentgate_R",
"channeldescr","cdname","cddelay","cderror","cddatarate","network","@27","@28",
"@29","@30","@31","@32","endnetwork","vector","inputvalue_or_expression","inputvalue",
"expression","expr","simple_expr","parameter_expr","string_expr","boolconst_expr",
"numconst_expr","special_expr","numconst","timeconstant","opt_semicolon","comma_or_semicolon", NULL
};
#endif

static const short yyr1[] = {     0,
    86,    86,    87,    87,    88,    88,    88,    88,    88,    90,
    89,    91,    91,    92,    93,    93,    93,    93,    93,    93,
    93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
    94,    96,    95,    97,    95,    98,    99,   100,   101,   102,
   103,   103,   104,   105,   106,   106,   107,   107,   108,   108,
   109,   109,   110,   110,   111,   111,   112,   112,   114,   113,
   115,   115,   116,   116,   117,   118,   120,   119,   121,   121,
   123,   122,   122,   124,   124,   124,   124,   124,   124,   124,
   124,   124,   126,   125,   127,   127,   128,   128,   128,   128,
   129,   129,   130,   130,   131,   131,   132,   132,   134,   133,
   135,   135,   136,   136,   138,   139,   137,   140,   141,   137,
   142,   143,   137,   144,   145,   137,   147,   146,   148,   148,
   149,   149,   151,   150,   152,   150,   153,   153,   154,   154,
   155,   156,   156,   157,   157,   159,   158,   160,   158,   161,
   161,   162,   162,   163,   164,   164,   166,   165,   167,   165,
   168,   168,   169,   169,   170,   170,   171,   171,   173,   172,
   174,   172,   175,   175,   176,   176,   177,   177,   179,   178,
   180,   180,   181,   182,   182,   183,   183,   184,   184,   185,
   185,   185,   185,   186,   186,   187,   187,   188,   188,   189,
   189,   190,   190,   191,   191,   192,   192,   193,   193,   194,
   194,   194,   194,   194,   194,   194,   194,   194,   194,   194,
   194,   194,   194,   194,   194,   194,   195,   196,   197,   198,
   200,   201,   202,   199,   203,   204,   205,   199,   206,   207,
   208,   208,   209,   209,   209,   209,   210,   211,   211,   211,
   211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
   211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
   211,   211,   211,   211,   211,   211,   211,   212,   212,   212,
   212,   212,   213,   213,   213,   213,   213,   213,   213,   213,
   213,   214,   215,   215,   216,   217,   217,   218,   218,   218,
   219,   219,   219,   219,   220,   220,   221,   221,   221
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     1,     1,     1,     1,     1,     0,
     3,     3,     2,     1,     2,     3,     3,     3,     4,     4,
     4,     4,     4,     4,     5,     5,     5,     5,     5,     5,
     2,     0,     4,     0,     3,     3,     3,     3,     5,     3,
     3,     2,     8,     3,     3,     2,     1,     0,     1,     0,
     1,     0,     1,     0,     1,     0,     1,     0,     0,     4,
     1,     0,     3,     2,     1,     4,     0,     4,     1,     0,
     0,     4,     2,     1,     3,     2,     3,     4,     4,     3,
     3,     3,     0,     4,     1,     0,     3,     2,     3,     2,
     3,     2,     3,     1,     3,     2,     3,     1,     0,     4,
     1,     0,     2,     1,     0,     0,     8,     0,     0,     9,
     0,     0,    10,     0,     0,    11,     0,     4,     1,     0,
     2,     1,     0,     4,     0,     6,     1,     0,     3,     2,
     1,     1,     0,     2,     1,     0,     4,     0,     6,     1,
     0,     3,     2,     3,     2,     0,     0,     4,     0,     6,
     1,     0,     3,     2,     2,     1,     4,     0,     0,     5,
     0,     4,     1,     0,     3,     2,     1,     1,     0,     6,
     3,     1,     5,     2,     0,     2,     0,     3,     2,     5,
     7,     5,     7,     3,     1,     2,     1,     2,     1,     2,
     1,     3,     1,     2,     1,     2,     1,     2,     1,     0,
     1,     1,     1,     1,     2,     2,     2,     2,     2,     2,
     3,     3,     3,     3,     3,     3,     1,     2,     2,     2,
     0,     0,     0,    11,     0,     0,     0,    13,     2,     3,
     1,     1,     6,     4,     3,     1,     1,     1,     3,     3,
     3,     3,     3,     3,     3,     2,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     2,     3,     3,     3,     2,
     3,     3,     5,     3,     4,     6,     8,     1,     1,     1,
     1,     1,     1,     2,     2,     3,     3,     3,     4,     4,
     5,     1,     1,     1,     1,     1,     4,     1,     1,     1,
     3,     3,     2,     2,     1,     0,     1,     1,     0
};

static const short yydefact[] = {     2,
    10,     0,     0,     0,     0,     1,     4,     5,     6,     0,
     7,    48,     8,    48,     9,     0,   296,    31,   296,     0,
     3,     0,     0,     0,   296,    15,     0,     0,     0,     0,
    52,    47,    52,    14,    11,     0,   295,    40,    44,     0,
   288,   289,   273,   282,   283,   284,     0,     0,     0,     0,
   286,     0,     0,     0,   296,   237,   238,   268,   269,   270,
   271,   272,   285,   290,   296,   296,   296,    34,    17,     0,
     0,    16,     0,     0,    18,     0,     0,    59,     0,    54,
    51,    54,     0,    13,   296,   293,   294,     0,     0,     0,
     0,   274,     0,   275,     0,   246,     0,   256,   260,     0,
    37,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    36,    38,    32,    35,    22,     0,    21,     0,
    19,     0,    20,     0,    24,     0,    23,     0,    62,    67,
     0,     0,    53,    56,    12,     0,   221,     0,     0,   291,
   292,     0,   278,   264,     0,     0,     0,     0,   276,   277,
     0,   239,   240,   241,   242,   243,   244,   245,   247,   248,
   249,   250,   251,   252,   253,   254,   255,   257,   258,   259,
   261,   262,     0,    33,    27,    28,    25,    26,    30,    29,
    65,    60,    61,     0,    70,    83,   296,    39,     0,    58,
    55,   296,   120,   230,     0,   265,   280,   279,     0,   287,
     0,     0,    64,    74,     0,    68,    69,     0,    86,   296,
    42,    99,     0,    50,    57,   225,     0,   222,   119,   122,
     0,   281,   263,    63,     0,    76,    71,    73,     0,     0,
    84,    85,    41,   102,     0,   161,     0,     0,    49,   120,
     0,   123,   133,   121,     0,   266,    77,    75,    80,    81,
    82,     0,    94,    88,     0,    98,    90,     0,     0,   100,
   101,   104,   159,   164,     0,   296,    43,   226,     0,   128,
     0,   223,   132,   135,     0,    78,    79,    72,     0,    87,
     0,    92,     0,    89,     0,    96,     0,   103,   164,   169,
   191,   162,   163,   299,   167,   168,     0,     0,   185,     0,
   296,    46,   133,   125,   131,   124,   127,     0,     0,   136,
     0,   134,   267,    93,    91,    97,    95,   296,   160,     0,
   190,   297,   166,     0,   200,   200,     0,    66,    45,   227,
   128,     0,   130,     0,   141,   296,   224,     0,   296,   105,
     0,     0,   172,   165,     0,     0,     0,   199,   175,     0,
   193,     0,   201,   202,   203,   204,   175,     0,   189,   184,
     0,   126,   129,   138,     0,   137,   140,     0,   229,   296,
     0,   108,   120,     0,     0,     0,   218,   219,   220,   198,
     0,   177,     0,     0,   205,   206,   208,   207,   209,   210,
   177,     0,   188,   228,   141,     0,     0,   143,   111,   296,
   120,   106,     0,     0,   299,   171,   174,     0,   182,   197,
   192,   199,   175,   211,   212,   213,   214,   215,   216,   180,
   175,   139,   236,   144,   231,   232,   142,   120,   114,   109,
   133,     0,   170,   179,     0,   176,   196,   177,   177,     0,
   112,   120,   133,   107,   117,   173,   178,   183,   181,   235,
     0,   133,   115,   110,   146,     0,   234,   113,   133,     0,
   158,   146,     0,   116,     0,   147,     0,   118,   145,   233,
     0,   152,     0,   149,   156,   148,   151,     0,     0,   152,
   155,     0,   154,   157,   150,   153,     0,     0,     0
};

static const short yydefgoto[] = {   497,
     6,     7,     8,    16,    35,    36,     9,    10,    26,   184,
   126,    27,    28,    29,    11,    12,   198,    13,    14,   277,
    31,   248,    80,   142,   200,   224,    32,   139,   192,   193,
   194,   249,    81,   195,   216,   217,   262,   218,   143,   219,
   241,   242,   264,   265,   267,   268,   201,   244,   270,   271,
   272,   383,   441,   411,   453,   438,   462,   452,   469,   454,
   465,   228,   229,   230,   280,   341,   316,   317,   318,   455,
   283,   284,   345,   405,   376,   377,   378,   471,   472,   482,
   490,   486,   487,   488,   478,   225,   299,   274,   302,   303,
   304,   305,   330,   352,   353,   392,   419,   414,   306,   307,
   308,   370,   309,   359,   360,   421,   361,   362,   363,   364,
   365,   366,    15,   203,   253,   321,   250,   313,   371,   347,
   390,   434,   435,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    38,   334
};

static const short yypact[] = {    13,
-32768,    -7,    28,   105,   121,-32768,    13,-32768,-32768,   124,
-32768,   135,-32768,   135,-32768,   172,   104,-32768,   104,   143,
-32768,   195,   195,   195,   -17,-32768,   155,   126,   183,   149,
   217,-32768,   217,-32768,-32768,   169,-32768,-32768,-32768,   221,
   223,   233,   140,-32768,-32768,-32768,   101,   175,   195,   194,
-32768,   195,   195,   195,   104,   507,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   104,   104,   104,-32768,-32768,   119,
    14,-32768,   119,   106,-32768,    14,   106,-32768,   242,   275,
-32768,   275,   172,-32768,   -16,   213,   213,   195,   255,    85,
   216,   -45,   284,-32768,   289,-32768,   293,-32768,-32768,   424,
-32768,   195,   195,   195,   195,   195,   195,   195,   195,   195,
   195,   195,   195,   195,   195,   195,   195,   195,   195,   195,
   195,   195,-32768,-32768,-32768,-32768,-32768,   329,-32768,   329,
-32768,   329,-32768,   329,-32768,   329,-32768,   329,   321,-32768,
   310,   333,-32768,   375,-32768,   351,-32768,   223,   233,-32768,
-32768,   311,-32768,-32768,   312,   353,   355,   313,-32768,-32768,
   309,-32768,   215,   215,   340,   340,   340,   340,   251,   251,
   251,   251,   251,   251,   222,   222,   222,   257,   257,   257,
   203,   203,   480,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   185,    -9,-32768,    -4,-32768,   322,   386,
-32768,   104,   368,-32768,   195,-32768,-32768,-32768,   370,-32768,
   195,   321,-32768,   347,   371,-32768,-32768,   210,   281,   104,
-32768,-32768,    -8,   411,-32768,-32768,    22,-32768,-32768,   368,
   395,-32768,   352,-32768,   294,-32768,-32768,-32768,   390,   391,
-32768,-32768,-32768,   392,   356,-32768,   357,   403,-32768,   368,
   195,-32768,   425,-32768,   195,-32768,   388,   393,-32768,-32768,
-32768,    -9,   359,   281,   235,   360,   281,   237,   361,-32768,
-32768,   392,-32768,     4,   397,    72,-32768,-32768,   365,   404,
    23,-32768,-32768,   425,   452,-32768,-32768,-32768,   381,-32768,
   390,-32768,   385,-32768,   391,-32768,   413,-32768,     4,-32768,
   157,-32768,-32768,   247,-32768,-32768,   317,   389,-32768,   402,
   104,-32768,   425,-32768,-32768,-32768,-32768,   266,   195,-32768,
   439,-32768,-32768,-32768,-32768,-32768,-32768,    35,-32768,   433,
   408,-32768,    11,     4,   112,   112,   457,-32768,-32768,-32768,
   404,   404,-32768,   422,   462,   104,-32768,   463,    -6,-32768,
   426,   496,   445,-32768,   195,   195,   195,   -13,   502,   446,
-32768,   509,-32768,   339,   199,   342,   502,   516,   467,-32768,
   439,-32768,-32768,-32768,   469,-32768,-32768,   272,-32768,   104,
   525,-32768,   368,   195,   526,   433,-32768,-32768,-32768,   471,
   195,   559,   540,   543,   575,   577,   575,   579,   577,   579,
   559,   543,-32768,-32768,   462,   159,   462,-32768,-32768,   104,
   368,-32768,   564,   556,   274,-32768,-32768,   549,-32768,   467,
-32768,   161,   502,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   502,-32768,   505,-32768,-32768,-32768,-32768,   368,-32768,-32768,
   425,   195,-32768,   552,   526,-32768,-32768,   559,   559,   137,
-32768,   368,   425,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   -48,   425,-32768,-32768,   580,   195,-32768,-32768,   425,    26,
   576,   580,   508,-32768,   195,-32768,   518,-32768,-32768,-32768,
   519,   558,   560,-32768,   467,-32768,-32768,   276,   521,   558,
-32768,   558,-32768,-32768,-32768,-32768,   597,   598,-32768
};

static const short yypgoto[] = {-32768,
   594,-32768,-32768,-32768,   520,-32768,-32768,-32768,    30,-32768,
-32768,    80,   111,   144,-32768,-32768,-32768,-32768,-32768,-32768,
   588,-32768,   571,   523,-32768,-32768,-32768,-32768,-32768,   394,
-32768,-32768,-32768,-32768,-32768,   345,-32768,-32768,-32768,-32768,
-32768,   -22,   318,-32768,   315,-32768,-32768,-32768,-32768,   336,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -429,
-32768,  -246,   382,-32768,-32768,-32768,   273,   269,-32768,  -242,
   331,-32768,-32768,-32768,   208,   209,-32768,   145,-32768,-32768,
-32768,   128,   127,-32768,-32768,-32768,-32768,-32768,   323,   286,
-32768,-32768,-32768,   238,-32768,  -326,  -396,   176,  -373,-32768,
-32768,-32768,-32768,  -333,-32768,-32768,-32768,   287,-32768,  -254,
  -351,  -248,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   254,
   -41,-32768,-32768,   -23,   -26,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   270,   -11,   211
};


#define	YYLAST		626


static const short yytable[] = {    65,
    66,    91,   367,   278,   430,  -217,  -217,    39,   146,   245,
   282,   415,   395,    68,   400,     1,     2,     3,   381,    22,
    67,     4,    96,   464,   300,    98,    99,   100,   214,   466,
    17,  -298,   468,   220,    88,   215,   467,   157,     5,   474,
   401,   301,    25,   101,   425,   251,   319,   428,  -298,   475,
   158,   458,   459,   123,   124,   125,    69,    72,    75,   348,
   423,    37,    37,   155,   152,    18,    88,   246,   431,  -195,
   340,   415,    37,   147,    37,   163,   164,   165,   166,   167,
   168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
   178,   179,   180,   181,   182,   183,   448,   252,   320,   127,
   129,   476,   131,   133,   449,   135,   137,    73,    76,   311,
   397,   399,    23,    37,    88,   396,   398,   355,   356,   357,
    41,    42,    43,    44,    45,    46,    24,    47,    48,    22,
    23,    24,    23,    24,    25,    49,   412,    70,    92,    77,
    50,    51,    19,   427,    93,   429,   424,    25,   426,   358,
    37,    52,    25,   134,    25,    53,   138,   185,    20,   186,
    22,   187,    24,   188,   440,   189,    30,   190,    54,   154,
    71,    74,    41,    42,    43,    44,    45,    46,   231,    47,
    48,   130,    37,    25,   233,   221,   136,    49,    22,    23,
   226,   451,    50,    51,    41,    42,    43,    44,    45,    46,
   433,    47,    48,    52,   355,   463,   357,    53,   243,    49,
    34,    25,    94,   128,    50,    51,   132,    95,    40,    88,
    54,   460,    89,    90,    78,    52,    79,   279,   285,    53,
    41,    42,    43,    44,    45,    46,    88,    47,    48,  -187,
    88,   290,    54,  -195,   294,    49,    83,    84,   148,   149,
    50,    51,   102,   103,   104,   105,   106,   107,    85,   331,
    86,    52,   212,   213,   312,    53,   104,   105,   106,   107,
    87,   102,   103,   104,   105,   106,   107,    97,    54,   108,
   109,   110,   111,   112,   113,   141,   349,   237,   238,   117,
   118,   119,   153,   120,   121,   344,   239,   240,   156,   339,
   102,   103,   104,   105,   106,   107,   102,   103,   104,   105,
   106,   107,   291,   292,   295,   296,   350,   140,   117,   118,
   119,   159,   120,   121,   332,   333,   160,   403,   120,   121,
   161,   387,   388,   389,   379,   335,   336,   382,   257,   258,
   259,   260,   261,   342,   343,   356,   357,   355,   356,   407,
   408,   332,   444,   492,   493,   150,   151,    25,   191,   197,
   413,   102,   103,   104,   105,   106,   107,   417,   409,   108,
   109,   110,   111,   112,   113,   114,   115,   116,   447,   117,
   118,   119,   436,   120,   121,   196,   122,   199,   202,   205,
   207,   204,   208,   210,   107,   209,   206,   222,   439,   223,
   227,   102,   103,   104,   105,   106,   107,   232,   236,   108,
   109,   110,   111,   112,   113,   114,   115,   116,   456,   117,
   118,   119,   235,   120,   121,   247,   461,   263,   266,   269,
   276,   273,   275,   286,   281,   310,   297,   287,   289,   293,
   314,   315,   473,   491,   102,   103,   104,   105,   106,   107,
   328,   481,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   324,   117,   118,   119,   326,   120,   121,   346,   122,
   351,   337,   255,   102,   103,   104,   105,   106,   107,   256,
   338,   108,   109,   110,   111,   112,   113,   114,   115,   116,
  -186,   117,   118,   119,   369,   120,   121,   374,   122,   375,
   380,   102,   103,   104,   105,   106,   107,   384,   162,   108,
   109,   110,   111,   112,   113,   114,   115,   116,   385,   117,
   118,   119,   386,   120,   121,   391,   122,   394,   393,   102,
   103,   104,   105,   106,   107,   402,   323,   108,   109,   110,
   111,   112,   113,   114,   115,   116,    88,   117,   118,   119,
   406,   120,   121,  -194,   122,   211,   102,   103,   104,   105,
   106,   107,   410,   301,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   418,   117,   118,   119,   420,   120,   121,
   422,   122,   357,   356,   355,   442,   443,   446,   450,  -298,
   477,   470,   480,   483,   484,   485,   498,   499,   489,   494,
    21,    33,   145,    82,   144,   234,   288,   298,   325,   327,
   373,   254,   432,   372,   322,   437,   479,   495,   496,   354,
   457,   329,   368,   416,   404,   445
};

static const short yycheck[] = {    23,
    24,    43,   336,   250,   401,    19,    20,    19,    25,    18,
   253,   385,   364,    25,   366,     3,     4,     5,    25,     6,
    38,     9,    49,   453,    21,    52,    53,    54,    38,    78,
    38,    21,   462,    38,    80,    45,    85,    83,    26,   469,
   367,    38,    29,    55,   396,    24,    24,   399,    38,    24,
    92,   448,   449,    65,    66,    67,    27,    28,    29,    25,
   394,    79,    79,    90,    88,    38,    80,    76,   402,    83,
   313,   445,    79,    85,    79,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   423,    76,    76,    70,
    71,    76,    73,    74,   431,    76,    77,    28,    29,    38,
   365,   366,     7,    79,    80,   364,   365,     6,     7,     8,
    36,    37,    38,    39,    40,    41,     8,    43,    44,     6,
     7,     8,     7,     8,    29,    51,   383,    27,    38,    29,
    56,    57,    38,   398,    44,   400,   395,    29,   397,    38,
    79,    67,    29,    74,    29,    71,    77,   128,    38,   130,
     6,   132,     8,   134,   411,   136,    32,   138,    84,    85,
    27,    28,    36,    37,    38,    39,    40,    41,   205,    43,
    44,    71,    79,    29,   211,   197,    76,    51,     6,     7,
   202,   438,    56,    57,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    67,     6,   452,     8,    71,   220,    51,
    39,    29,    38,    70,    56,    57,    73,    43,    76,    80,
    84,    85,    83,    84,    76,    67,    10,   251,   255,    71,
    36,    37,    38,    39,    40,    41,    80,    43,    44,    83,
    80,   264,    84,    83,   267,    51,    78,    79,    36,    37,
    56,    57,    50,    51,    52,    53,    54,    55,    38,   301,
    38,    67,    78,    79,   276,    71,    52,    53,    54,    55,
    38,    50,    51,    52,    53,    54,    55,    84,    84,    58,
    59,    60,    61,    62,    63,    11,   328,    78,    79,    68,
    69,    70,    38,    72,    73,   319,    16,    17,    83,   311,
    50,    51,    52,    53,    54,    55,    50,    51,    52,    53,
    54,    55,    78,    79,    78,    79,   328,    76,    68,    69,
    70,    38,    72,    73,    78,    79,    38,   369,    72,    73,
    38,   355,   356,   357,   346,    19,    20,   349,    45,    46,
    47,    48,    49,    78,    79,     7,     8,     6,     7,    78,
    79,    78,    79,    78,    79,    86,    87,    29,    38,    27,
   384,    50,    51,    52,    53,    54,    55,   391,   380,    58,
    59,    60,    61,    62,    63,    64,    65,    66,   420,    68,
    69,    70,   406,    72,    73,    76,    75,    13,    38,    78,
    38,    81,    38,    85,    55,    83,    85,    76,   410,    14,
    33,    50,    51,    52,    53,    54,    55,    38,    38,    58,
    59,    60,    61,    62,    63,    64,    65,    66,   442,    68,
    69,    70,    76,    72,    73,    15,   450,    38,    38,    38,
    28,    76,    76,    46,    10,    39,    76,    45,    80,    80,
    76,    38,   466,   485,    50,    51,    52,    53,    54,    55,
    38,   475,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    81,    68,    69,    70,    81,    72,    73,    30,    75,
    38,    83,    78,    50,    51,    52,    53,    54,    55,    85,
    79,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    83,    68,    69,    70,    38,    72,    73,    76,    75,    38,
    38,    50,    51,    52,    53,    54,    55,    82,    85,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    23,    68,
    69,    70,    78,    72,    73,    24,    75,    19,    83,    50,
    51,    52,    53,    54,    55,    20,    85,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    80,    68,    69,    70,
    82,    72,    73,    83,    75,    76,    50,    51,    52,    53,
    54,    55,    38,    38,    58,    59,    60,    61,    62,    63,
    64,    65,    66,    15,    68,    69,    70,    38,    72,    73,
    38,    75,     8,     7,     6,    22,    31,    39,    84,    38,
    15,    12,    85,    76,    76,    38,     0,     0,    39,    79,
     7,    14,    83,    33,    82,   212,   262,   272,   291,   295,
   342,   230,   405,   341,   284,   407,   472,   490,   492,   334,
   445,   299,   336,   386,   371,   415
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 10:
#line 233 "ebnf.y"
{GNED( IMPORTS_KEY = np->create("imports",NEDFILE_KEY);
                       setComments(IMPORTS_KEY,yylsp[0]); );
    break;}
case 11:
#line 236 "ebnf.y"
{/* GNED( setTrailingComment(IMPORTS_KEY,@3); )
                  * comment already stored with last filename */;
    break;}
case 14:
#line 247 "ebnf.y"
{NEDC( do_include (yyvsp[0]); )
                 GNED( IMPORT_KEY = np->create("import",IMPORTS_KEY);
                       np->set(IMPORT_KEY,"name",trimQuotes(yylsp[0]));
                       setComments(IMPORT_KEY,yylsp[0]); );
    break;}
case 15:
#line 256 "ebnf.y"
{NEDC( do_channel (yyvsp[-1], NULL, NULL, NULL); );
    break;}
case 16:
#line 259 "ebnf.y"
{NEDC( do_channel (yyvsp[-2], yyvsp[-1], NULL, NULL); );
    break;}
case 17:
#line 261 "ebnf.y"
{NEDC( do_channel (yyvsp[-2], NULL, yyvsp[-1], NULL); );
    break;}
case 18:
#line 263 "ebnf.y"
{NEDC( do_channel (yyvsp[-2], NULL, NULL, yyvsp[-1]); );
    break;}
case 19:
#line 266 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL); );
    break;}
case 20:
#line 268 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-2], NULL, yyvsp[-1]); );
    break;}
case 21:
#line 270 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], NULL, yyvsp[-2], yyvsp[-1]); );
    break;}
case 22:
#line 272 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-1], yyvsp[-2], NULL); );
    break;}
case 23:
#line 274 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-1], NULL, yyvsp[-2]); );
    break;}
case 24:
#line 276 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], NULL, yyvsp[-1], yyvsp[-2]); );
    break;}
case 25:
#line 279 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1]); );
    break;}
case 26:
#line 281 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[-2]); );
    break;}
case 27:
#line 283 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-2], yyvsp[-3], yyvsp[-1]); );
    break;}
case 28:
#line 285 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-1], yyvsp[-3], yyvsp[-2]); );
    break;}
case 29:
#line 287 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[-3]); );
    break;}
case 30:
#line 289 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-1], yyvsp[-2], yyvsp[-3]); );
    break;}
case 31:
#line 294 "ebnf.y"
{NEDC( yyval = yyvsp[0]; inside_nonvoid_function=1;)
                 GNED( CHANNEL_KEY = np->create("channel",NEDFILE_KEY);
                       np->set(CHANNEL_KEY,"name",yylsp[0]);
                       setComments(CHANNEL_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 32:
#line 303 "ebnf.y"
{NEDC( inside_nonvoid_function=0; );
    break;}
case 33:
#line 304 "ebnf.y"
{GNED( setTrailingComment(CHANNEL_KEY,yylsp[-2]); );
    break;}
case 34:
#line 306 "ebnf.y"
{NEDC( inside_nonvoid_function=0; );
    break;}
case 35:
#line 307 "ebnf.y"
{GNED( setTrailingComment(CHANNEL_KEY,yylsp[-2]); );
    break;}
case 36:
#line 313 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; )
                 GNED( CHANATTR_KEY = addChanAttr(CHANNEL_KEY,"error",yylsp[-1]);
                       setComments(CHANATTR_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 37:
#line 320 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; )
                 GNED( CHANATTR_KEY = addChanAttr(CHANNEL_KEY,"delay",yylsp[-1]);
                       setComments(CHANATTR_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 38:
#line 327 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; )
                 GNED( CHANATTR_KEY = addChanAttr(CHANNEL_KEY,"datarate",yylsp[-1]);
                       setComments(CHANATTR_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 40:
#line 342 "ebnf.y"
{NEDC( do_simple (yyvsp[-1]); )
                 GNED( MODULE_KEY = np->create("simple",NEDFILE_KEY);
                       np->set(MODULE_KEY,"name", yylsp[-1]);
                       setComments(MODULE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 41:
#line 351 "ebnf.y"
{NEDC( end_simple (yyvsp[-1]); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 42:
#line 354 "ebnf.y"
{NEDC( end_simple (NULL); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 44:
#line 371 "ebnf.y"
{NEDC( do_module (yyvsp[-1]); )
                 GNED( MODULE_KEY = np->create("module",NEDFILE_KEY);
                       np->set(MODULE_KEY,"name", yylsp[-1]);
                       setComments(MODULE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 45:
#line 379 "ebnf.y"
{NEDC( end_module (yyvsp[-1]); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 46:
#line 382 "ebnf.y"
{NEDC( end_module (NULL); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 48:
#line 389 "ebnf.y"
{NEDC( do_machine(jar_strdup("default")); );
    break;}
case 59:
#line 399 "ebnf.y"
{GNED( MACHINES_KEY = np->create("machines",MODULE_KEY);
                       setComments(MACHINES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 65:
#line 415 "ebnf.y"
{NEDC( do_machine (yyvsp[0]); )
                 GNED( MACHINE_KEY = np->create("machine",MACHINES_KEY);
                       np->set(MACHINE_KEY,"name", yylsp[0]);
                       setComments(MACHINE_KEY,yylsp[0],yylsp[0]); );
    break;}
case 66:
#line 423 "ebnf.y"
{NEDC( do_displaystr_enclosing (yyvsp[-1]); )
                 GNED( setDisplayString(MODULE_KEY,yylsp[-1]); );
    break;}
case 67:
#line 429 "ebnf.y"
{NEDC( do_parameters (); )
                 GNED( PARAMS_KEY = np->create("params",MODULE_KEY);
                       setComments(PARAMS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 71:
#line 442 "ebnf.y"
{GNED( setComments(PARAM_KEY,yylsp[-1]); );
    break;}
case 73:
#line 445 "ebnf.y"
{GNED( setComments(PARAM_KEY,yylsp[-1]); );
    break;}
case 74:
#line 450 "ebnf.y"
{NEDC( do_parameter (yyvsp[0], TYPE_NUMERIC); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[0],TYPE_NUMERIC); );
    break;}
case 75:
#line 453 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_NUMERIC); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_NUMERIC); );
    break;}
case 76:
#line 456 "ebnf.y"
{NEDC( do_parameter (yyvsp[0], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[0],TYPE_CONST_NUM); );
    break;}
case 77:
#line 459 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_CONST_NUM); );
    break;}
case 78:
#line 462 "ebnf.y"
{NEDC( do_parameter (yyvsp[-3], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-3],TYPE_CONST_NUM); );
    break;}
case 79:
#line 465 "ebnf.y"
{NEDC( do_parameter (yyvsp[-3], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-3],TYPE_CONST_NUM); );
    break;}
case 80:
#line 468 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_STRING); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_STRING); );
    break;}
case 81:
#line 471 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_BOOL); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_BOOL); );
    break;}
case 82:
#line 474 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_ANYTYPE); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_ANYTYPE); );
    break;}
case 83:
#line 480 "ebnf.y"
{NEDC( do_gates (); )
                 GNED( GATES_KEY = np->create("gates",MODULE_KEY);
                       setComments(GATES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 93:
#line 505 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[-2], 1, 1 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[-2], 1, 1 );
                       setComments(GATE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 94:
#line 509 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[0], 1, 0 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[0], 1, 0 );
                       setComments(GATE_KEY,yylsp[0]); );
    break;}
case 97:
#line 521 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[-2], 0, 1 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[-2], 0, 1 );
                       setComments(GATE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 98:
#line 525 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[0], 0, 0 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[0], 0, 0 );
                       setComments(GATE_KEY,yylsp[0]); );
    break;}
case 99:
#line 532 "ebnf.y"
{NEDC( do_submodules (); )
                 GNED( SUBMODS_KEY = np->create("submods",MODULE_KEY);
                       setComments(SUBMODS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 105:
#line 550 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-3], NULL, yyvsp[-1], NULL); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-3], NULLPOS, yylsp[-1], NULLPOS);
                       setComments(SUBMOD_KEY,yylsp[-3],yylsp[0]);  );
    break;}
case 106:
#line 554 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-5], NULL, yyvsp[-3], NULL); );
    break;}
case 108:
#line 557 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-4], yyvsp[-1], yyvsp[-2], NULL); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-4], yylsp[-1], yylsp[-2], NULLPOS);
                       setComments(SUBMOD_KEY,yylsp[-4],yylsp[0]);  );
    break;}
case 109:
#line 561 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-6], yyvsp[-3], yyvsp[-4], NULL); );
    break;}
case 111:
#line 564 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-5], NULL, yyvsp[-3], yyvsp[-1]); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-5], NULLPOS, yylsp[-3], yylsp[-1]);
                       setComments(SUBMOD_KEY,yylsp[-5],yylsp[0]);  );
    break;}
case 112:
#line 568 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-7], NULL, yyvsp[-5], yyvsp[-3]); );
    break;}
case 114:
#line 571 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-6], yyvsp[-3], yyvsp[-4], yyvsp[-1]); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-6], yylsp[-3], yylsp[-4], yylsp[-1]);
                       setComments(SUBMOD_KEY,yylsp[-6],yylsp[0]);  );
    break;}
case 115:
#line 575 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-8], yyvsp[-5], yyvsp[-6], yyvsp[-3]); );
    break;}
case 117:
#line 581 "ebnf.y"
{NEDC( do_readallparameters(); );
    break;}
case 118:
#line 584 "ebnf.y"
{NEDC( end_submodule (); );
    break;}
case 120:
#line 590 "ebnf.y"
{NEDC( do_empty_onlist(); );
    break;}
case 123:
#line 600 "ebnf.y"
{NEDC( do_onlist(); )
                 GNED( SUBSTMACHINES_KEY = np->create("substmachines",in_network?NETWORK_KEY:SUBMOD_KEY);
                       setComments(SUBSTMACHINES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 125:
#line 605 "ebnf.y"
{NEDC( open_if(yyvsp[-1]); do_onlist(); )
                 GNED( SUBSTMACHINES_KEY = np->create("substmachines",in_network?NETWORK_KEY:SUBMOD_KEY);
                       np->set(SUBSTMACHINES_KEY,"condition",yylsp[-1]);
                       setComments(SUBSTMACHINES_KEY,yylsp[-3],yylsp[0]); );
    break;}
case 126:
#line 610 "ebnf.y"
{NEDC( close_if(); );
    break;}
case 128:
#line 616 "ebnf.y"
{NEDC( do_empty_onlist(); );
    break;}
case 131:
#line 626 "ebnf.y"
{NEDC( do_on_mach(yyvsp[0]); )
                 GNED( SUBSTMACHINE_KEY = addSubstmachine(SUBSTMACHINES_KEY,yylsp[0]);
                       setComments(SUBSTMACHINE_KEY,yylsp[0]); );
    break;}
case 136:
#line 643 "ebnf.y"
{NEDC( do_substparams (); )
                 GNED( SUBSTPARAMS_KEY = np->create("substparams",in_network?NETWORK_KEY:SUBMOD_KEY);
                       setComments(SUBSTPARAMS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 138:
#line 648 "ebnf.y"
{NEDC( open_if(yyvsp[-1]); do_substparams(); )
                 GNED( SUBSTPARAMS_KEY = np->create("substparams",in_network?NETWORK_KEY:SUBMOD_KEY);
                       np->set(SUBSTPARAMS_KEY,"condition",yylsp[-1]);
                       setComments(SUBSTPARAMS_KEY,yylsp[-3],yylsp[0]); );
    break;}
case 139:
#line 653 "ebnf.y"
{NEDC( close_if(); );
    break;}
case 144:
#line 667 "ebnf.y"
{NEDC( do_substparameter (yyvsp[-2], yyvsp[0]);)
                 GNED( SUBSTPARAM_KEY = addSubstparam(SUBSTPARAMS_KEY,yylsp[-2],yylsp[0]);
                       setComments(SUBSTPARAM_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 147:
#line 679 "ebnf.y"
{NEDC( do_gatesizes (); )
                 GNED( GATESIZES_KEY = np->create("gatesizes",SUBMOD_KEY);
                       setComments(GATESIZES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 149:
#line 684 "ebnf.y"
{NEDC( open_if(yyvsp[-1]); do_gatesizes (); )
                 GNED( GATESIZES_KEY = np->create("gatesizes",SUBMOD_KEY);
                       np->set(GATESIZES_KEY,"condition",yylsp[-1]);
                       setComments(GATESIZES_KEY,yylsp[-3],yylsp[0]); );
    break;}
case 150:
#line 689 "ebnf.y"
{NEDC( close_if(); );
    break;}
case 155:
#line 703 "ebnf.y"
{NEDC( do_gatesize (yyvsp[-1], yyvsp[0]); )
                 GNED( GATESIZE_KEY = addGateSize(GATESIZES_KEY,yylsp[-1],yylsp[0]);
                       setComments(GATESIZE_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 156:
#line 707 "ebnf.y"
{NEDC( do_gatesize (yyvsp[0], NULL); )
                 GNED( GATESIZE_KEY = addGateSize(GATESIZES_KEY,yylsp[0],NULLPOS);
                       setComments(GATESIZE_KEY,yylsp[0]); );
    break;}
case 157:
#line 714 "ebnf.y"
{NEDC( do_displaystr_submod (yyvsp[-1]); )
                 GNED( setDisplayString(SUBMOD_KEY,yylsp[-1]); );
    break;}
case 159:
#line 721 "ebnf.y"
{NEDC( set_checkconns(0); do_connections(); )
                 GNED( CONNS_KEY = np->create("conns",MODULE_KEY);
                       np->set(CONNS_KEY,"nocheck","1");
                       setComments(CONNS_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 161:
#line 727 "ebnf.y"
{NEDC( set_checkconns(1); do_connections(); )
                 GNED( CONNS_KEY = np->create("conns",MODULE_KEY);
                       np->set(CONNS_KEY,"nocheck","0");
                       setComments(CONNS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 169:
#line 751 "ebnf.y"
{NEDC( do_for (); )
                 GNED( FORLOOP_KEY = np->create("forloop",CONNS_KEY);
                       in_loop=1; setComments(FORLOOP_KEY,yylsp[0]); );
    break;}
case 170:
#line 755 "ebnf.y"
{NEDC( end_for (); )
                 GNED( in_loop=0; setTrailingComment(FORLOOP_KEY,yylsp[0]); );
    break;}
case 173:
#line 766 "ebnf.y"
{NEDC( do_index (yyvsp[-4], yyvsp[-2], yyvsp[0]); )
                 GNED( LOOPVAR_KEY=addLoopVar(FORLOOP_KEY,yylsp[-4],yylsp[-2],yylsp[0]);
                       setComments(LOOPVAR_KEY,yylsp[-4],yylsp[0]); );
    break;}
case 174:
#line 773 "ebnf.y"
{NEDC( do_condition(yyvsp[0]); )
                 GNED( np->set(CONN_KEY,"condition",yylsp[0]); );
    break;}
case 175:
#line 776 "ebnf.y"
{NEDC( do_condition(NULL); );
    break;}
case 176:
#line 781 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( setDisplayString(CONN_KEY,yylsp[0]); );
    break;}
case 177:
#line 784 "ebnf.y"
{NEDC( yyval = NULL; );
    break;}
case 180:
#line 794 "ebnf.y"
{NEDC( end_connection (NULL, 'R', yyvsp[0]); )
                 GNED( np->set(CONN_KEY,"arrowdir-l2r",1L); setComments(CONN_KEY,yylsp[-4],yylsp[0]); );
    break;}
case 181:
#line 797 "ebnf.y"
{NEDC( end_connection (yyvsp[-4], 'R', yyvsp[0]); )
                 GNED( np->set(CONN_KEY,"arrowdir-l2r",1L); setComments(CONN_KEY,yylsp[-6],yylsp[0]); );
    break;}
case 182:
#line 800 "ebnf.y"
{NEDC( end_connection (NULL, 'L', yyvsp[0]); )
                 GNED( swapConnection(CONN_KEY);
                       np->set(CONN_KEY,"arrowdir-l2r",0L); setComments(CONN_KEY,yylsp[-4],yylsp[0]); );
    break;}
case 183:
#line 804 "ebnf.y"
{NEDC( end_connection (yyvsp[-4], 'L', yyvsp[0]); )
                 GNED( swapConnection(CONN_KEY);
                 np->set(CONN_KEY,"arrowdir-l2r",0L); setComments(CONN_KEY,yylsp[-6],yylsp[0]); );
    break;}
case 186:
#line 816 "ebnf.y"
{NEDC( do_mod_L (yyvsp[-1], yyvsp[0]); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", findSubmoduleKey(yylsp[-1]));
                       np->set(CONN_KEY, "src-mod-index", trimBrackets(yylsp[0])); );
    break;}
case 187:
#line 821 "ebnf.y"
{NEDC( do_mod_L (yyvsp[0], NULL); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", findSubmoduleKey(yylsp[0])); );
    break;}
case 188:
#line 828 "ebnf.y"
{NEDC( do_gate_L (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "srcgate", yylsp[-1]);
                       np->set(CONN_KEY, "src-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 189:
#line 832 "ebnf.y"
{NEDC( do_gate_L (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "srcgate", yylsp[0]); );
    break;}
case 190:
#line 838 "ebnf.y"
{NEDC( do_mod_L (NULL, NULL); do_gate_L (yyvsp[-1], yyvsp[0]); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "srcgate", yylsp[-1]);
                       np->set(CONN_KEY, "src-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 191:
#line 844 "ebnf.y"
{NEDC( do_mod_L (NULL, NULL); do_gate_L (yyvsp[0], NULL); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "srcgate", yylsp[0]); );
    break;}
case 194:
#line 857 "ebnf.y"
{NEDC( do_mod_R (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", findSubmoduleKey(yylsp[-1]));
                       np->set(CONN_KEY, "dest-mod-index", trimBrackets(yylsp[0])); );
    break;}
case 195:
#line 861 "ebnf.y"
{NEDC( do_mod_R (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", findSubmoduleKey(yylsp[0])); );
    break;}
case 196:
#line 867 "ebnf.y"
{NEDC( do_gate_R (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "destgate", yylsp[-1]);
                       np->set(CONN_KEY, "dest-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 197:
#line 871 "ebnf.y"
{NEDC( do_gate_R (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "destgate", yylsp[0]); );
    break;}
case 198:
#line 877 "ebnf.y"
{NEDC( do_mod_R (NULL, NULL); do_gate_R (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "destgate", yylsp[-1]);
                       np->set(CONN_KEY, "dest-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 199:
#line 882 "ebnf.y"
{NEDC( do_mod_R (NULL, NULL); do_gate_R (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "destgate", yylsp[0]); );
    break;}
case 200:
#line 890 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, NULL, NULL); );
    break;}
case 201:
#line 892 "ebnf.y"
{NEDC( yyval = do_channeldescr(yyvsp[0], NULL,NULL,NULL); );
    break;}
case 202:
#line 894 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], NULL, NULL); );
    break;}
case 203:
#line 896 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, yyvsp[0], NULL); );
    break;}
case 204:
#line 898 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, NULL, yyvsp[0]); );
    break;}
case 205:
#line 901 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], yyvsp[0], NULL); );
    break;}
case 206:
#line 903 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], NULL, yyvsp[0]); );
    break;}
case 207:
#line 905 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, yyvsp[-1], yyvsp[0]); );
    break;}
case 208:
#line 907 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], yyvsp[-1], NULL); );
    break;}
case 209:
#line 909 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], NULL, yyvsp[-1]); );
    break;}
case 210:
#line 911 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, yyvsp[0], yyvsp[-1]); );
    break;}
case 211:
#line 914 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-2], yyvsp[-1], yyvsp[0]); );
    break;}
case 212:
#line 916 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-2], yyvsp[0], yyvsp[-1]); );
    break;}
case 213:
#line 918 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], yyvsp[-2], yyvsp[0]); );
    break;}
case 214:
#line 920 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], yyvsp[-2], yyvsp[-1]); );
    break;}
case 215:
#line 922 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], yyvsp[0], yyvsp[-2]); );
    break;}
case 216:
#line 924 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], yyvsp[-1], yyvsp[-2]); );
    break;}
case 217:
#line 929 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"channel",yylsp[0]); );
    break;}
case 218:
#line 935 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"delay",yylsp[0]); );
    break;}
case 219:
#line 941 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"error",yylsp[0]); );
    break;}
case 220:
#line 947 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"datarate",yylsp[0]); );
    break;}
case 221:
#line 953 "ebnf.y"
{NEDC( do_system (yyvsp[-3]); )
                 GNED( NETWORK_KEY = addNetwork(NEDFILE_KEY,yylsp[-3],yylsp[-1],NULLPOS);
                       setComments(NETWORK_KEY,yylsp[-4],yylsp[0]); in_network=1;);
    break;}
case 222:
#line 957 "ebnf.y"
{NEDC( do_systemmodule (yyvsp[-5], yyvsp[-3], NULL); );
    break;}
case 223:
#line 959 "ebnf.y"
{NEDC( do_readallparameters(); );
    break;}
case 224:
#line 961 "ebnf.y"
{NEDC( end_system (); );
    break;}
case 225:
#line 963 "ebnf.y"
{NEDC( do_system (yyvsp[-5]); );
    break;}
case 226:
#line 965 "ebnf.y"
{NEDC( do_systemmodule (yyvsp[-7], yyvsp[-5], yyvsp[-3]); )
                 GNED( NETWORK_KEY = addNetwork(NEDFILE_KEY,yylsp[-7],yylsp[-5],yylsp[-3]);
                       setComments(NETWORK_KEY,yylsp[-8],yylsp[-2]); );
    break;}
case 227:
#line 969 "ebnf.y"
{NEDC( do_readallparameters(); );
    break;}
case 228:
#line 971 "ebnf.y"
{NEDC( end_system (); );
    break;}
case 229:
#line 976 "ebnf.y"
{GNED( setTrailingComment(NETWORK_KEY,yylsp[-1]); in_network=0; );
    break;}
case 230:
#line 981 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; );
    break;}
case 233:
#line 991 "ebnf.y"
{NEDC( yyval = do_inputvalue(yyvsp[-3], yyvsp[-1]); );
    break;}
case 234:
#line 993 "ebnf.y"
{NEDC( yyval = do_inputvalue(yyvsp[-1], NULL); );
    break;}
case 235:
#line 995 "ebnf.y"
{NEDC( yyval = do_inputvalue(NULL, NULL); );
    break;}
case 236:
#line 997 "ebnf.y"
{NEDC( yyval = do_inputvalue(NULL, NULL); );
    break;}
case 237:
#line 1003 "ebnf.y"
{NEDC( yyval = end_expr( yyvsp[0] ); );
    break;}
case 238:
#line 1008 "ebnf.y"
{NEDC( yyval = yyvsp[0]; );
    break;}
case 239:
#line 1010 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; );
    break;}
case 240:
#line 1013 "ebnf.y"
{NEDC( yyval = do_op( 2, '+', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 241:
#line 1015 "ebnf.y"
{NEDC( yyval = do_op( 2, '-', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 242:
#line 1017 "ebnf.y"
{NEDC( yyval = do_op( 2, '*', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 243:
#line 1019 "ebnf.y"
{NEDC( yyval = do_op( 2, '/', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 244:
#line 1021 "ebnf.y"
{NEDC( yyval = do_op( 2, '%', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 245:
#line 1023 "ebnf.y"
{NEDC( yyval = do_op( 2, '^', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 246:
#line 1027 "ebnf.y"
{NEDC( yyval = do_addminus(yyvsp[0]); );
    break;}
case 247:
#line 1030 "ebnf.y"
{NEDC( yyval = do_op( 2, '=', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 248:
#line 1032 "ebnf.y"
{NEDC( yyval = do_op( 2, '!', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 249:
#line 1034 "ebnf.y"
{NEDC( yyval = do_op( 2, '>', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 250:
#line 1036 "ebnf.y"
{NEDC( yyval = do_op( 2, '}', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 251:
#line 1038 "ebnf.y"
{NEDC( yyval = do_op( 2, '<', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 252:
#line 1040 "ebnf.y"
{NEDC( yyval = do_op( 2, '{', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 253:
#line 1043 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bool_and"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 254:
#line 1045 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bool_or"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 255:
#line 1047 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bool_xor"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 256:
#line 1050 "ebnf.y"
{NEDC( yyval = do_func(1,jar_strdup("bool_not"), yyvsp[0],NULL,NULL); );
    break;}
case 257:
#line 1053 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bin_and"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 258:
#line 1055 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bin_or"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 259:
#line 1057 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bin_xor"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 260:
#line 1060 "ebnf.y"
{NEDC( yyval = do_func(1,jar_strdup("bin_compl"), yyvsp[0],NULL,NULL); );
    break;}
case 261:
#line 1062 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("shift_left"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 262:
#line 1064 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("shift_right"), yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 263:
#line 1066 "ebnf.y"
{NEDC( yyval = do_op( 3, '?', yyvsp[-4],yyvsp[-2],yyvsp[0]); );
    break;}
case 264:
#line 1068 "ebnf.y"
{NEDC( yyval = do_func(0,yyvsp[-2], NULL,NULL,NULL); );
    break;}
case 265:
#line 1070 "ebnf.y"
{NEDC( yyval = do_func(1,yyvsp[-3], yyvsp[-1],NULL,NULL); );
    break;}
case 266:
#line 1072 "ebnf.y"
{NEDC( yyval = do_func(2,yyvsp[-5], yyvsp[-3],yyvsp[-1],NULL); );
    break;}
case 267:
#line 1074 "ebnf.y"
{NEDC( yyval = do_func(3,yyvsp[-7], yyvsp[-5],yyvsp[-3],yyvsp[-1]); );
    break;}
case 273:
#line 1087 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],0,1); );
    break;}
case 274:
#line 1089 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],0,0); );
    break;}
case 275:
#line 1091 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],1,1); );
    break;}
case 276:
#line 1093 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],1,0); );
    break;}
case 277:
#line 1095 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],1,0); );
    break;}
case 278:
#line 1098 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-2],0,yyvsp[0],0,1); );
    break;}
case 279:
#line 1100 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-2],0,yyvsp[0],0,0); );
    break;}
case 280:
#line 1103 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-3],yyvsp[-2],yyvsp[0],0,1); );
    break;}
case 281:
#line 1105 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-3],yyvsp[-2],yyvsp[0],0,0); );
    break;}
case 282:
#line 1110 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_STRING,yyvsp[0]); );
    break;}
case 283:
#line 1115 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_BOOL,jar_strdup("TRUE")); );
    break;}
case 284:
#line 1117 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_BOOL,jar_strdup("FALSE")); );
    break;}
case 285:
#line 1122 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_NUMERIC,yyvsp[0]); );
    break;}
case 286:
#line 1127 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_NUMERIC,jar_strdup("(long)sub_i")); );
    break;}
case 287:
#line 1129 "ebnf.y"
{NEDC( yyval = do_sizeof (yyvsp[-1]); );
    break;}
case 291:
#line 1140 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-2],yyvsp[-1],yyvsp[0]); );
    break;}
case 292:
#line 1142 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-2],yyvsp[-1],yyvsp[0]); );
    break;}
case 293:
#line 1144 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-1],yyvsp[0],NULL); );
    break;}
case 294:
#line 1146 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-1],yyvsp[0],NULL); );
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1153 "ebnf.y"


//----------------------------------------------------------------------
// general bison/flex stuff:
//

char yyfailure[250] = "";
extern int yydebug; /* needed if compiled with yacc --VA */

extern char textbuf[];
extern char lasttextbuf[];

int runparse ()
{
#if YYDEBUG != 0      /* #if added --VA */
        yydebug = YYDEBUGGING_ON;
#endif
        pos.co = 0;
        pos.li = 1;
        prevpos = pos;

        strcpy (lasttextbuf, "");
        strcpy (yyfailure, "");

        if (yyin)
            yyrestart( yyin );

        return yyparse();
}

#ifdef DOING_NEDC

extern char current_fname[];

void yyerror (char *s)
{
        fflush (stdout);
        if (strlen (s))
                strcpy (yyfailure, s);
        if (yyfailure [strlen (yyfailure) - 1] != '\n')
                strcat (yyfailure, "\n");
        if (yyfailure [0] == '!')
                fprintf(stderr,
                        "Warning %s %d: %s",
                        current_fname, pos.li, yyfailure + 1);
        else
                /*-- fprintf(stderr,
                        "line %d: (E) %s----\t%s\n----\t%s\n\t%*s\n",
                        pos.li, yyfailure, lasttextbuf, textbuf, pos.co, "^");
                 -- shortened --VA*/
                fprintf(stderr,
                        "Error %s %d: %s> %s\n  %*s\n",
                        current_fname, pos.li, yyfailure, textbuf, pos.co, "^");
}

#endif


#ifdef DOING_GNED

void yyerror (char *s)
{
        if (strlen (s))
                strcpy (yyfailure, s);
        if (yyfailure [strlen(yyfailure)-1] == '\n')
                yyfailure [strlen(yyfailure)-1] = '\0';

        if (yyfailure [0] == '!')
                np->error('W', yyfailure, pos.li, pos.co);
        else
                np->error('E', yyfailure, pos.li, pos.co);
}

#endif


//----------------------------------------------------------------------
//
// stuff needed by GNED
//

#ifdef DOING_GNED

void setFileComment(int key)
{
    np->set(key,"comment", np->nedsource->getFileComment());
}

void setBannerComment(int key, YYLTYPE tokenpos)
{
    np->set(key,"banner-comment", np->nedsource->getBannerComment(tokenpos));
}

void setRightComment(int key, YYLTYPE tokenpos)
{
    np->set(key,"right-comment", np->nedsource->getTrailingComment(tokenpos));
}

void setTrailingComment(int key, YYLTYPE tokenpos)
{
    np->set(key,"trailing-comment", np->nedsource->getTrailingComment(tokenpos));
}

void setComments(int key, YYLTYPE pos)
{
    setBannerComment(key, pos);
    setRightComment(key, pos);
}

void setComments(int key, YYLTYPE firstpos, YYLTYPE lastpos)
{
    YYLTYPE pos = firstpos;
    pos.last_line = lastpos.last_line;
    pos.last_column = lastpos.last_column;

    setBannerComment(key, pos);
    setRightComment(key, pos);
}

int addChanAttr(int channel_key, char *attrname, YYLTYPE valuepos)
{
    int chanattr_key = np->create("chanattr", channel_key);
    np->set(chanattr_key,"name", attrname);
    np->set(chanattr_key,"value", valuepos);
    return chanattr_key;
}

int addParameter(int params_key, YYLTYPE namepos, int type)
{
   char *s;
   switch (type)
   {
       case TYPE_NUMERIC:   s = "numeric"; break;
       case TYPE_CONST_NUM: s = "numeric const"; break;
       case TYPE_STRING:    s = "string"; break;
       case TYPE_BOOL:      s = "bool"; break;
       case TYPE_ANYTYPE:   s = "anytype"; break;
       default: s="?";
   }

   int param_key = np->create("param", params_key);
   np->set(param_key, "name", namepos);
   np->set(param_key, "datatype", s);
   return param_key;
}

int addGate(int gates_key, YYLTYPE namepos, int is_in, int is_vector )
{
   int gate_key = np->create("gate", gates_key);
   np->set(gate_key, "name", namepos);
   np->set(gate_key, "gatetype", is_in ? "in" : "out");
   np->set(gate_key, "isvector", is_vector ? "1" : "0");
   return gate_key;
}

int addSubmodule(int submods_key, YYLTYPE namepos, YYLTYPE vectorpos,
                                  YYLTYPE typepos,YYLTYPE likepos)
{
   // cut off "[" and "]"
   vectorpos.first_column++;
   vectorpos.last_column--;

   int submod_key = np->create("submod", submods_key);
   np->set(submod_key, "name", namepos);
   np->set(submod_key, "type-name", typepos);
   np->set(submod_key, "vectorsize", vectorpos);
   np->set(submod_key, "like-name", likepos);

   return submod_key;
}

int addGateSize(int gatesizes_key, YYLTYPE namepos, YYLTYPE vectorpos)
{
   // cut off "[" and "]"
   vectorpos.first_column++;
   vectorpos.last_column--;

   int gatesize_key = np->create("gatesize", gatesizes_key);
   np->set(gatesize_key, "name", namepos);
   np->set(gatesize_key, "size", vectorpos);
   return gatesize_key;
}

int addSubstparam(int substparams_key, YYLTYPE namepos, YYLTYPE valuepos)
{
   int substparam_key = np->create("substparam", substparams_key);
   np->set(substparam_key, "name", namepos);
   np->set(substparam_key, "value", valuepos);
   return substparam_key;
}

int addSubstmachine(int substmachines_key, YYLTYPE namepos)
{
   int substmachine_key = np->create("substmachine", substmachines_key);
   np->set(substmachine_key, "value", namepos);
   return substmachine_key;
}

int addLoopVar(int forloop_key, YYLTYPE varnamepos, YYLTYPE frompos, YYLTYPE topos)
{
   int loopvar_key = np->create("loopvar", forloop_key);
   np->set(loopvar_key, "name", varnamepos);
   np->set(loopvar_key, "fromvalue", frompos);
   np->set(loopvar_key, "tovalue", topos);
   return loopvar_key;
}

int addConnAttr(int conn_key, char *attrname, YYLTYPE valuepos)
{
    int connattr_key = np->create("connattr", conn_key);
    np->set(connattr_key,"name", attrname);
    np->set(connattr_key,"value", valuepos);
    return connattr_key;
}


int addNetwork(int nedfile_key, YYLTYPE namepos, YYLTYPE typepos, YYLTYPE likepos)
{
   int network_key = np->create("network", nedfile_key);
   np->set(network_key, "name", namepos);
   np->set(network_key, "type-name", typepos);
   np->set(network_key, "like-name", likepos);

   return network_key;
}

int findSubmoduleKey(YYLTYPE modulenamepos)
{
   int key = np->findChild(SUBMODS_KEY,"name",np->nedsource->get(modulenamepos));

   if (key==-1)
      yyerror("invalid submodule name");
   else if (key==-2)
      yyerror("nonunique submodule name");
   return key;
}

YYLTYPE trimBrackets(YYLTYPE vectorpos)
{
   // should check it's really brackets that get chopped off
   vectorpos.first_column++;
   vectorpos.last_column--;
   return vectorpos;
}

YYLTYPE trimQuotes(YYLTYPE vectorpos)
{
   // should check it's really quotes that get chopped off
   vectorpos.first_column++;
   vectorpos.last_column--;
   return vectorpos;
}

void swapConnection(int conn_key)
{
   np->swap(conn_key, "src-ownerkey", "dest-ownerkey");
   np->swap(conn_key, "srcgate", "destgate");
   np->swap(conn_key, "src-mod-index", "dest-mod-index");
   np->swap(conn_key, "src-gate-index", "dest-gate-index");
}

void setDisplayString(int key, YYLTYPE dispstrpos)
{
  // cut off quotes
  dispstrpos.first_column++;
  dispstrpos.last_column--;

  np->set(key,"displaystring", np->nedsource->get(dispstrpos) );
}


#endif



